﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Configuration;
using System.IO;
using Microsoft.Extensions.Configuration;
using System.Threading;
using BPASmartClient.Helper;
using BPASmartClient.Message;
using BPA.ApolloClient;
using BPA.ApolloClient.Options;
using Com.Ctrip.Framework.Apollo;

namespace BPASmartClient.Business
{
    /// <summary>
    /// 网络信息数据
    /// </summary>
    public class InternetInfo
    {
        /// <summary>
        /// 配置初始化
        /// </summary>
        public static void InitConfig()
        {
            NetworkConnectState = UniversalHelper.GetInstance().GetNetworkState();
            while (!NetworkConnectState)
            {
                NetworkConnectState = UniversalHelper.GetInstance().GetNetworkState();
                Thread.Sleep(2000);
            }
        }

        /// <summary>
        /// 网络连接状态
        /// </summary>
        public static bool NetworkConnectState { get; set; }

        #region API地址

        /// <summary>
        /// Api 网关地址
        /// </summary>
        public static string ApiAddress { get; set; }

        /// <summary>
        /// 订单服务
        /// </summary>
        public static string OrderServer { get; set; }

        /// <summary>
        /// 库存服务
        /// </summary>
        public static string StockServer { get; set; }

        /// <summary>
        /// 是否启用测试模式
        /// </summary>
        public static bool IsEnableTest { get; set; }

        /// <summary>
        /// 大屏地址
        /// </summary>
        public static string DataVApiAddress { get; set; }

        /// <summary>
        /// 大屏主题
        /// </summary>
        public static string BroadcastPubTopic { get; set; }

        /// <summary>
        /// 物料管理地址
        /// </summary>
        public static string WebServiceUri { get; set; }
        #endregion

    }
}
